﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace UnpackMicrosoftSources
{
    public class UnpackSource
    {
        private String BuildPath(String[] Path)
        {
            String CurrentCompletePath = ".\\";

            foreach(String PathPart in Path)
            {
                CurrentCompletePath = CurrentCompletePath+PathPart;

                if (!Directory.Exists(CurrentCompletePath))
                {
                    // create it...
                    Directory.CreateDirectory(CurrentCompletePath);
                }

                CurrentCompletePath = CurrentCompletePath+"\\";
            }

            return CurrentCompletePath;
        }

        public void Go(String InputFilename, String InputFilter)
        {
            Console.Write("Reading it all in...");
            string[] lines = System.IO.File.ReadAllLines(InputFilename);
            Console.WriteLine("Done.");

            Console.WriteLine("Parsing...");

            //String ToBeRemovedAndFound = args[1];
            String ToBeRemovedAndFound = InputFilter;
            StreamWriter OutputFile = null;

            foreach (string line in lines)
            {
                // check if it's a new file...
                if (line.Contains(ToBeRemovedAndFound))
                {
                    Int32 removeuntil = line.IndexOf(',');
                    String TempLine = line.Remove(0, removeuntil + 1);
                    removeuntil = TempLine.IndexOf(',');
                    TempLine = TempLine.Remove(removeuntil, TempLine.Length - removeuntil);
                    TempLine = TempLine.Replace(ToBeRemovedAndFound, "");
                    String FileName = TempLine.Remove(0, TempLine.LastIndexOf('/') + 1);
                    Int32 StartIndex = (TempLine.LastIndexOf('/') - 2) - FileName.Length;
                    String[] Path = TempLine.Remove(StartIndex, TempLine.Length - StartIndex).Split(new char[1] { '/' }, StringSplitOptions.RemoveEmptyEntries);
                    Console.WriteLine(TempLine.Remove(StartIndex, TempLine.Length - StartIndex) + FileName);
                    if (OutputFile != null)
                        OutputFile.Close();

                    OutputFile = new StreamWriter(BuildPath(Path)+FileName, false, Encoding.Unicode);
                }
                else
                {
                    // must be a text line...
                    if (OutputFile != null)
                        OutputFile.WriteLine(line);
                }
            }

        }
    }
}
